package cn.ibizlab.humanresource.core.base.service;

import java.io.Serializable;
import java.sql.Timestamp;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.util.HashMap;
import java.util.Collection;
import java.math.BigInteger;

import org.springframework.data.domain.Page;
import org.springframework.data.domain.Pageable;
import com.alibaba.fastjson.JSONObject;
import org.springframework.cache.annotation.CacheEvict;

import cn.ibizlab.humanresource.core.base.domain.HROrganization;
import cn.ibizlab.humanresource.core.base.filter.HROrganizationSearchContext;


import com.baomidou.mybatisplus.extension.service.IService;

/**
 * 实体[HROrganization] 服务对象接口
 */
public interface IHROrganizationService extends IService<HROrganization>{

    boolean create(HROrganization et) ;
    void createBatch(List<HROrganization> list) ;
    boolean update(HROrganization et) ;
    void updateBatch(List<HROrganization> list) ;
    boolean remove(String key) ;
    void removeBatch(Collection<String> idList) ;
    HROrganization get(String key) ;
    HROrganization getDraft(HROrganization et) ;
    boolean checkKey(HROrganization et) ;
    boolean save(HROrganization et) ;
    void saveBatch(List<HROrganization> list) ;
    Page<HROrganization> searchDefault(HROrganizationSearchContext context) ;
    /**
     *自定义查询SQL
     * @param sql  select * from table where id =#{et.param}
     * @param param 参数列表  param.put("param","1");
     * @return select * from table where id = '1'
     */
    List<JSONObject> select(String sql, Map param);
    /**
     *自定义SQL
     * @param sql  update table  set name ='test' where id =#{et.param}
     * @param param 参数列表  param.put("param","1");
     * @return     update table  set name ='test' where id = '1'
     */
    boolean execute(String sql, Map param);

    List<HROrganization> getHrorganizationByIds(List<String> ids) ;
    List<HROrganization> getHrorganizationByEntities(List<HROrganization> entities) ;
}


